Booster = {}

local function newBooster(x, y)
    local size = { x = 40, y = 10 }
    return {
        score = 1,
        expireAfterCollision = true,
        size = size,
        position = { x = x, y = y },
        canBounce = {
            flat = { x = 122, y = 190 },
            mult = { x = 1, y = -0.5 },
        },
        drawAsRectangle = { size = size },
    }
end

boosterIndex = 1
boosterCache = {}
for i = 1, 100 do
    boosterCache[i] = newBooster(-999, 999)
end

function Booster.cacheSize()
    return #boosterCache
end

-- Boosters should be "initialized" almost always increasing in X value
function Booster.get(x, y)
    local booster = boosterCache[boosterIndex]
    booster.position.x = x
    booster.position.y = y

    boosterIndex = boosterIndex + 1
    if boosterIndex > #boosterCache then
        boosterIndex = 1
    end

    return booster
end

-- Assumes that at least one Booster has already been created.
function Booster.newestBooster()
    return boosterCache[boosterIndex]
end
