collisionDetection = filteredSystem(
    { position = T.XyPair, size = T.XyPair, isSolid = Maybe(T.bool) },
    -- Here, the entity, e, refers to some entity that the burger global(!) may be colliding with.
    function(e, _, system)
        local collider = burger
        if not collider.velocity then
            return
        end
        local colliderTop = collider.position.y
        local colliderBottom = collider.position.y + collider.size.y
        local entityTop = e.position.y
        local entityBottom = entityTop + e.size.y

        local withinY = (entityTop > colliderTop and entityTop < colliderBottom)
            or (entityBottom > colliderTop and entityBottom < colliderBottom)

        if not withinY then
            return
        end

        if collider.position.x < e.position.x + e.size.x and collider.position.x + collider.size.x > e.position.x then
            system.world:addEntity({ collisionBetween = { e, collider } })
            if e.expireAfterCollision then
                system.world:removeEntity(e)
            end
        end
    end
)
