collisionResolution = filteredSystem({ collisionBetween = T.Collision }, function(e, _, system)
    local collider, probablyBurger = e.collisionBetween[1], e.collisionBetween[2]
    local colliderTop = collider.position.y

    if collider.isSolid then
        -- Assumes impact from the top
        probablyBurger.position.y = colliderTop - probablyBurger.size.y
    end

    if collider.canBounce and probablyBurger.canBeBounced then
        probablyBurger.velocity.x = probablyBurger.velocity.x
            + collider.canBounce.flat.x
            + probablyBurger.canBeBounced.flat.x

        probablyBurger.velocity.x = probablyBurger.velocity.x
            * collider.canBounce.mult.x
            * probablyBurger.canBeBounced.mult.x

        -- abs() makes sure we always push upward
        probablyBurger.velocity.y = math.abs(probablyBurger.velocity.y)
            + collider.canBounce.flat.y
            + probablyBurger.canBeBounced.flat.y

        probablyBurger.velocity.y = probablyBurger.velocity.y
            * collider.canBounce.mult.y
            * probablyBurger.canBeBounced.mult.y
    end

    if collider.score then
        Score:add(collider.score)
    end

    if collider.expireAfterCollision then
        system.world:removeEntity(collider)
    end

    system.world:removeEntity(e)
end)
